<?php


namespace App\Controller;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\Routing\Annotation\Route;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use App\Entity\Commande;

class CommandeController extends AbstractController
{
    /**
     * @Route("/listCommandes",name="show_Commandes")
     */
    public function listCommandes(Request $request)
    {
       
        $Commandes = $this->getDoctrine()
            ->getRepository(Commande::class)
            ->findAll();



        return $this->render('commandes/main.html.twig', array('Commandes' => $Commandes));


    }



    /**
     * @Route("/addCommande", name="add_Commande")
     */
    public function addCommande(Request $request){
        $nom=$request->request->get('nom');        
        $fabricant=$request->request->get('fabricant');
        $capacite=$request->request->get('capacite');
        $longueur=$request->request->get('longueur');
        
        $em = $this->getDoctrine()->getManager();

        /** @var TYPE_NAME $exception */
        try {

            $entityManager = $this->getDoctrine()->getManager();

            $Commande=new TapeCommandee();
            $Commande->setNom($nom);
            $Commande->setFabricant($fabricant);
            $Commande->setCapacite($capacite);
            $Commande->setLongueur($longueur);
            $Commande->setDatecreation(new \DateTime());
            $entityManager->persist($Commande);
            $entityManager->flush();

            $response = new Response(json_encode(array(
                'status' => '200',
                'message' => 'Base de données mise à jour'
            )));

        }
        catch (DBALException $e) {

            $response = new Response(json_encode(array(
                'status' => '500',
                'message' => $e
            )));
        }


        $response->headers->set('Content-Type', 'application/json');
        return $response;

    }

    /**
     * @Route("/editCommande", name="edit_Commande")
     */
    public function editCommande(Request $request){

        $id=$request->request->get('id');
        $nom=$request->request->get('nom');
        $fabricant=$request->request->get('fabricant');
        $capacite=$request->request->get('capacite');
        $longueur=$request->request->get('longueur');

        $em = $this->getDoctrine()->getManager();

        /** @var TYPE_NAME $exception */
        try {

            $id=$request->request->get('id');
            $em = $this->getDoctrine()->getManager();

            $Commande=$this->getDoctrine()
                ->getRepository(TapeCommandee::class)->find($id);
            $Commande->setNom($nom);
            $Commande->setFabricant($fabricant);
            $Commande->setCapacite($capacite);
            $Commande->setLongueur($longueur);

            $em->persist($Commande);
            $em->flush();

            $response = new Response(json_encode(array(
                'status' => '200',
                'message' => 'Base de données mise à jour'
            )));

        }
        catch (DBALException $e) {

            $response = new Response(json_encode(array(
                'status' => '500',
                'message' => $e
            )));
        }


        $response->headers->set('Content-Type', 'application/json');
        return $response;

    }

    /**
     * @Route("/removeCommande", name="remove_Commande")
     */
    public function removeCommande(Request $request){
        $id=$request->request->get('id');
        $em = $this->getDoctrine()->getManager();

        /** @var TYPE_NAME $exception */
        try {
            $Commande=$this->getDoctrine()
                ->getRepository(TapeCommandee::class)->find($id);

            $em->remove($Commande);
            $em->flush($Commande);


            $response = new Response(json_encode(array(
                'status' => '200',
                'message' => 'Base de données mise à jour'
            )));

        }
        catch (DBALException $e) {

            $response = new Response(json_encode(array(
                'status' => '500',
                'message' => $e
            )));
        }


        $response->headers->set('Content-Type', 'application/json');
        return $response;

    }

}